Attribute VB_Name = "ProcessArray_bas"
Option Explicit

Private Const MAX_PATH = 260

Public Declare Function CloseHandle Lib "Kernel32.dll" _
(ByVal Handle As Long) As Long

'win 9x part

Private Const TH32CS_SNAPPROCESS = 2&

Private Type PROCESSENTRY32
    lSize            As Long
    lUsage           As Long
    lProcessId       As Long
    lDefaultHeapId   As Long
    lModuleId        As Long
    lThreads         As Long
    lParentProcessId As Long
    lPriClassBase    As Long
    lFlags           As Long
    sExeFile         As String * MAX_PATH
End Type

Private Declare Function CreateToolhelpSnapshot Lib "kernel32" _
    Alias "CreateToolhelp32Snapshot" (ByVal lFlags As Long, _
    ByVal lProcessId As Long) As Long
    
Private Declare Function ProcessFirst Lib "kernel32" _
    Alias "Process32First" (ByVal hSnapshot As Long, _
    uProcess As PROCESSENTRY32) As Long
    
Private Declare Function ProcessNext Lib "kernel32" _
    Alias "Process32Next" (ByVal hSnapshot As Long, _
    uProcess As PROCESSENTRY32) As Long

'winnt part

Private Declare Function OpenProcess Lib "Kernel32.dll" _
(ByVal dwDesiredAccessas As Long, ByVal bInheritHandle As Long, _
   ByVal dwProcId As Long) As Long

Private Declare Function EnumProcesses Lib "psapi.dll" _
(ByRef lpidProcess As Long, ByVal cb As Long, _
   ByRef cbNeeded As Long) As Long

Private Declare Function GetModuleFileNameExA Lib "psapi.dll" _
(ByVal hProcess As Long, ByVal hModule As Long, _
   ByVal ModuleName As String, ByVal nSize As Long) As Long

Private Declare Function EnumProcessModules Lib "psapi.dll" _
(ByVal hProcess As Long, ByRef lphModule As Long, _
   ByVal cb As Long, ByRef cbNeeded As Long) As Long

Private Const PROCESS_QUERY_INFORMATION = 1024
Private Const PROCESS_VM_READ = 16

Public Type process
   ModuleName As String
   Pid As Long
   ParentPid As Long
   Thread As Long
End Type

Public Sub FillProcessArray(allprocess() As process)
   Dim i As Long
   
   If OS_RunOn = OS_WIN98 Then
      Dim lSnapShot  As Long
      Dim r          As Long
      Dim uProcess   As PROCESSENTRY32
      
      i = 0
      ReDim allprocess(0)
      
      lSnapShot = CreateToolhelpSnapshot(TH32CS_SNAPPROCESS, 0&)
      If lSnapShot <> 0 Then
         uProcess.lSize = Len(uProcess)
         r = ProcessFirst(lSnapShot, uProcess)
         
         Do While r
            i = i + 1
            ReDim Preserve allprocess(i)
            allprocess(i).ModuleName = Left$(uProcess.sExeFile, InStr(1, uProcess.sExeFile, vbNullChar) - 1)
            allprocess(i).Pid = uProcess.lProcessId
            allprocess(i).ParentPid = uProcess.lParentProcessId
            allprocess(i).Thread = uProcess.lThreads
            r = ProcessNext(lSnapShot, uProcess)
         Loop
         Call CloseHandle(lSnapShot)
      End If
   Else
      Dim cb As Long
      Dim cbNeeded As Long
      Dim NumElements As Long
      Dim ProcessIDs() As Long
      Dim cbNeeded2 As Long
      Dim NumElements2 As Long
      Dim Modules(1 To 200) As Long
      Dim lRet As Long
      Dim ModuleName As String
      Dim nSize As Long
      Dim hProcess As Long
      'Get the array containing the process id's for each process object
      
      ReDim allprocess(0)
      cb = 8
      cbNeeded = 96
      Do While cb <= cbNeeded
         cb = cb * 2
         ReDim ProcessIDs(cb / 4) As Long
         lRet = EnumProcesses(ProcessIDs(1), cb, cbNeeded)
      Loop
      NumElements = cbNeeded / 4

      For i = 1 To NumElements
         ReDim Preserve allprocess(i)
         allprocess(i).Pid = ProcessIDs(i)
         'Get a handle to the Process
         hProcess = OpenProcess(PROCESS_QUERY_INFORMATION _
            Or PROCESS_VM_READ, 0, ProcessIDs(i))
         'Got a Process handle
         If hProcess <> 0 Then
             'Get an array of the module handles for the specified
             'process
             lRet = EnumProcessModules(hProcess, Modules(1), 200, _
                                          cbNeeded2)
             'If the Module Array is retrieved, Get the ModuleFileName
             If lRet <> 0 Then
                ModuleName = Space(MAX_PATH)
                nSize = 500
                lRet = GetModuleFileNameExA(hProcess, Modules(1), _
                                ModuleName, nSize)
                allprocess(i).ModuleName = Left(ModuleName, lRet)
             Else
                allprocess(i).ModuleName = ""
             End If
         End If
       'Close the handle to the process
         lRet = CloseHandle(hProcess)
      Next i
   End If
End Sub
