Attribute VB_Name = "TaskList_bas"
Option Explicit
'
' Required Win32 API Declarations
'
Private Declare Function EnumWindows Lib "user32" (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Private Declare Function IsWindowVisible Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hwnd As Long, lpdwProcessId As Long) As Long

Private Declare Function OpenProcess Lib "kernel32" _
    (ByVal dwDesiredAccess As Long, _
     ByVal bInheritHandle As Long, _
     ByVal dwProcessId As Long) As Long

Private Declare Function CloseHandle Lib "kernel32" _
    (ByVal hObject As Long) As Long

Private Const PROCESS_QUERY_INFORMATION = &H400

Private Declare Function GetModuleFileName Lib "kernel32" Alias _
   "GetModuleFileNameA" (ByVal hModule As Long, ByVal lpFileName As _
   String, ByVal nSize As Long) As Long
'
' Constant used to determine window owner.
'
Private Const GWL_WNDPROC = (-4)
Private Const GWL_HINSTANCE = (-6)
Private Const GWL_HWNDPARENT = (-8)
Private Const GWL_STYLE = (-16)
Private Const GWL_EXSTYLE = (-20)
Private Const GWL_USERDATA = (-21)
Private Const GWL_ID = (-12)

'Constants for determining what windows to display
Public Const WIN_TOP = 0
Public Const WIN_ALL = 1
Public Const WIN_VISIBLE = 2

Public Type window
   hwnd As Long
   wndtext As String
   hwnd_parent As Long
   hwnd_owner As Long
   hInst As Double
   processId As Long
   processModule As String
End Type
Dim tempallwindows() As window

'
' Private variables needed to support enumeration
'
Private nb_wnd As Long
Private Filling As Integer

Public Sub FillTaskArray(How As Integer, allwindows() As window)
   '
   ' Fill an array with the current running Tasks
   '
   Filling = How
   nb_wnd = 0
   ReDim tempallwindows(nb_wnd)
   Call EnumWindows(AddressOf EnumWindowsProc, 0)
   allwindows() = tempallwindows()
End Sub

Private Function EnumWindowsProc(ByVal hwnd As Long, ByVal lParam As Long) As Long
   Static WindowText As String
   Static nRet As Long
   Dim curwndparent As Long
   Dim curwndowner As Long
   Dim lThreadId  As Long
   Dim r As Long
   Dim sModuleFileName As String * 255
   Dim hProcess As Long
   '
   ' Make sure we meet visibility requirements.
   '
   If Filling = WIN_ALL Then GoTo DoAll
   If IsWindowVisible(hwnd) Then
DoAll:
      WindowText = Space$(256)
      '
      ' Retrieve windowtext (caption)
      '
      nRet = GetWindowText(hwnd, WindowText, Len(WindowText))
      If nRet Then
         '
         ' Clean up window text and add to list.
         '
         nb_wnd = nb_wnd + 1
         ReDim Preserve tempallwindows(nb_wnd)
         tempallwindows(nb_wnd).wndtext = Left$(WindowText, nRet)
         tempallwindows(nb_wnd).hwnd = hwnd
         '
         ' It shouldn't have any parent window, either.
         '
         tempallwindows(nb_wnd).hwnd_parent = GetParent(hwnd)
         '
         ' And, finally, it shouldn't have an owner.
         '
         tempallwindows(nb_wnd).hwnd_owner = GetWindowLong(hwnd, GWL_HWNDPARENT)
         '
         ' Get the hinstance
         '
         tempallwindows(nb_wnd).hInst = GetWindowLong(hwnd, GWL_HINSTANCE)
         '
         ' Get process
         '
         lThreadId = GetWindowThreadProcessId(tempallwindows(nb_wnd).hwnd, tempallwindows(nb_wnd).processId)
         '
         ' Get module file name:
         '
         r = GetModuleFileName(tempallwindows(nb_wnd).hInst, sModuleFileName, 255)
         tempallwindows(nb_wnd).processModule = Left(sModuleFileName, r)
         If Len(tempallwindows(nb_wnd).processModule) = 0 Then tempallwindows(nb_wnd).processModule = " "

      End If
   End If
   '
   ' Return True to continue enumeration.
   '
   EnumWindowsProc = True
End Function


