Attribute VB_Name = "desktopshorcut_bas"
Option Explicit
'
' Desktopvirtual folder
Private Const CSIDL_DESKTOP = &H0
'
' User's program groups
Private Const CSIDL_PROGRAMS = &H2
'
' Control Panel.
Private Const CSIDL_CONTROLS = &H3
'
' Folder containing installed printers.
Private Const CSIDL_PRINTERS = &H4
'
' Folder that serves as a common repository for documents.
Private Const CSIDL_PERSONAL = &H5
'
' Folder that serves as a common repository for the user's favorite items.
Private Const CSIDL_FAVORITES = &H6
'
' Folder that corresponds to the user's Startup program group.
Private Const CSIDL_STARTUP = &H7
'
' User's most recently used documents.
Private Const CSIDL_RECENT = &H8
'
' Folder that contains Send To menu items.
Private Const CSIDL_SENDTO = &H9
'
' Recycle Bin.
Private Const CSIDL_BITBUCKET = &HA
'
' Start menu items.
Private Const CSIDL_STARTMENU = &HB
'
' Folder used to physically store file objects on the desktop.
Private Const CSIDL_DESKTOPDIRECTORY = &H10
'
' My Computervirtual folder
Private Const CSIDL_DRIVES = &H11
'
' Network Neighborhood
Private Const CSIDL_NETWORK = &H12
'
' Network neighborhood.
Private Const CSIDL_NETHOOD = &H13
'
' Virtual folder containing fonts.
Private Const CSIDL_FONTS = &H14
'
' Document templates.
Private Const CSIDL_TEMPLATES = &H15
'
' Folder that contains the programs and folders that
' appear on the Start menu for all users.
Private Const CSIDL_COMMON_STARTMENU = &H16
'
' Folder  that contains the directories for the common
' program groups that appear on the Start menu for all users.
Private Const CSIDL_COMMON_PROGRAMS = &H17
'
' Folder that contains the programs that appear in the
' Startup folder for all users.
Private Const CSIDL_COMMON_STARTUP = &H18
'
' Folder that contains files and folders that
' appear on the desktop for all users.
Private Const CSIDL_COMMON_DESKTOPDIRECTORY = &H19
'
' Folder serving as a common repository for
' application-specificdata.
Private Const CSIDL_APPDATA = &H1A
'
' Folder that serves as a common repository for printer links.
Private Const CSIDL_PRINTHOOD = &H1B

Private Const FO_MOVE = &H1
Private Const FO_RENAME = &H4
Private Const FOF_SILENT = &H4
Private Const FOF_NOCONFIRMATION = &H10
Private Const FOF_RENAMEONCOLLISION = &H8
Private Const MAX_PATH As Integer = 260
Private Const SHARD_PATH = &H2&
Private Const SHCNF_IDLIST = &H0
Private Const SHCNE_ALLEVENTS = &H7FFFFFFF

Private Type SHFILEOPSTRUCT
    hwnd      As Long
    wFunc     As Long
    pFrom     As String
    pTo       As String
    fFlags    As Integer
    fAborted  As Boolean
    hNameMaps As Long
    sProgress As String
End Type

Private Type SHITEMID
    cb   As Long
    abID As Byte
End Type

Private Type ITEMIDLIST
    mkid As SHITEMID
End Type

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

' Retrieves the ID of a special folder.
Private Declare Function SHGetSpecialFolderLocation Lib "Shell32.dll" _
    (ByVal hwndOwner As Long, ByVal nFolder As Long, pidl As ITEMIDLIST) As Long

' Type safe version of SHGetSpecialFolderLocationD.
Private Declare Function SHGetSpecialFolderLocationD Lib "Shell32.dll" _
    Alias "SHGetSpecialFolderLocation" (ByVal hwndOwner As Long, _
    ByVal nFolder As Long, ByRef ppidl As Long) As Long

' Adds a document to the shell's list of recently used documents or
' clears all documents from the list. The user gains access to the
' list through the Start menu of the Windows taskbar.
Private Declare Function SHAddToRecentDocs Lib "Shell32.dll" _
    (ByVal dwFlags As Long, ByVal dwdata As String) As Long

' Copies, moves, renames, or deletes a file.
Private Declare Function SHFileOperation Lib "Shell32.dll" _
    Alias "SHFileOperationA" (lpFileOp As SHFILEOPSTRUCT) As Long

' Notifies the system of an event that an application has performed.
Private Declare Function SHChangeNotify Lib "Shell32.dll" _
    (ByVal wEventID As Long, ByVal uFlags As Long, _
    ByVal dwItem1 As Long, ByVal dwItem2 As Long) As Long

' Converts an item identifier list to a file system path.
Private Declare Function SHGetPathFromIDList Lib "Shell32.dll" _
    Alias "SHGetPathFromIDListA" (ByVal pidl As Long, _
    ByVal pszPath As String) As Long

Public Sub Createdesktopshorcut(mainhwnd As Long, txtApp As String, txtName As String)
   Dim i             As Integer
   Dim lResult       As Long
   Dim lpil          As Long
   Dim sFilePath     As String
   Dim sFileName     As String
   Dim sRecentPath   As String
   Dim sDesktopPath  As String
   Dim sFilePathOld  As String
   Dim sFilePathNew  As String
   Dim sShortCutName As String
   'Dim sMsg          As String
   Dim SHFileOp      As SHFILEOPSTRUCT
   '
   ' Add a shortcut to the Windows desktop.
   '
   If Trim$(txtApp) = "" Or Trim$(txtName) = "" Then Exit Sub
   
   On Error GoTo cmdCreateError
   'Screen.MousePointer = vbHourglass
   sFilePath = Trim$(txtApp)
   sShortCutName = Trim$(txtName) & ".lnk"
   '
   ' Get the paths of the folders to add the shortcuts to.
   ' The folders are the Recent Files List and the Desktop.
   '
   sRecentPath = fGetSpecialFolder(mainhwnd, CSIDL_RECENT)
   sDesktopPath = fGetSpecialFolder(mainhwnd, CSIDL_DESKTOPDIRECTORY)
   'sMsg = "Error retrieving folder location."
   If sRecentPath <> "" And sDesktopPath <> "" Then
       '
       ' Create a shortcut in the Recent Files list. The
       ' SHARD_PATH flag says that the following parameter
       ' is a path.
       '
       'sMsg = "Error adding shortcut to the Recent File list."
       lResult = SHAddToRecentDocs(SHARD_PATH, sFilePath)
       DoEvents
       Sleep (750)
       If lResult Then
           '
           ' Extract the .exe name from the path.
           '
           i = 1
           sFileName = sFilePath
           Do While i
               i = InStr(1, sFileName, "\")
               If i Then sFileName = Mid$(sFileName, i + 1)
           Loop
           '
           ' Move the shortcut from the Recent folder to the Desktop.
           ' Since the shortcut now resides in the Recent folder,
           ' modify the file name to include the Recent folder
           ' path. Also, append ".lnk" to the original filename.
           '
           
           sFilePath = sRecentPath & sFileName & ".lnk" & vbNullChar & vbNullChar
           With SHFileOp
               .wFunc = FO_MOVE
               .pFrom = sFilePath
               .pTo = sDesktopPath
               .fFlags = FOF_SILENT
           End With
   
           'sMsg = "Error creating desktop shortcut."
           lResult = SHFileOperation(SHFileOp)
           DoEvents
           Sleep (750)
           If lResult = 0 Then
               '
               ' Rename the link.
               '
               sFilePathOld = sDesktopPath & sFileName & ".lnk" & vbNullChar & vbNullChar
               sFilePathNew = sDesktopPath & sShortCutName & vbNullChar & vbNullChar
               With SHFileOp
                   .wFunc = FO_RENAME
                   .pFrom = sFilePathOld
                   .pTo = sFilePathNew
                   .fFlags = FOF_SILENT Or FOF_RENAMEONCOLLISION
               End With
               'sMsg = "Error renaming desktop shortcut."
               lResult = SHFileOperation(SHFileOp) '123 = can't rename.
               'sMsg = ""
               '
               ' Refresh the desktop to display the shortcut.
               '
               Call SHGetSpecialFolderLocationD(mainhwnd, CSIDL_DESKTOP, lpil)
               Call SHChangeNotify(SHCNE_ALLEVENTS, SHCNF_IDLIST, lpil, 0)
           End If
       End If
   End If
   
   'Screen.MousePointer = vbDefault
   On Error GoTo 0
   Exit Sub
   
cmdCreateError:
   Err.Clear
   On Error GoTo 0
       'MsgBox "Error creating desktop shortcut. " & sMsg, vbExclamation, "Create Shortcut"
End Sub

Private Function fGetSpecialFolder(mainhwnd As Long, CSIDL As Long) As String
   Dim sPath As String
   Dim IDL   As ITEMIDLIST
   '
   ' Retrieve info about system folders such as the
   ' "Recent Documents" folder.  Info is stored in
   ' the IDL structure.
   '
   fGetSpecialFolder = ""
   If SHGetSpecialFolderLocation(mainhwnd, CSIDL, IDL) = 0 Then
       '
       ' Get the path from the ID list, and return the folder.
       '
       sPath = Space$(MAX_PATH)
       If SHGetPathFromIDList(ByVal IDL.mkid.cb, ByVal sPath) Then
           fGetSpecialFolder = Left$(sPath, InStr(sPath, vbNullChar) - 1) & "\"
       End If
   End If
End Function

