Attribute VB_Name = "RAS_bas"
Option Explicit

Private Enum RASCONNSTATE
   RASCS_OpenPort = 0
   RASCS_PortOpened = 1
   RASCS_ConnectDevice = 2
   RASCS_DeviceConnected = 3
   RASCS_AllDevicesConnected = 4
   RASCS_Authenticate = 5
   RASCS_AuthNotify = 6
   RASCS_AuthRetry = 7
   RASCS_AuthCallback = 8
   RASCS_AuthChangePassword = 9
   RASCS_AuthProject = 10
   RASCS_AuthLinkSpeed = 11
   RASCS_AuthAck = 12
   RASCS_ReAuthenticate = 13
   RASCS_Authenticated = 14
   RASCS_PrepareForCallback = 15
   RASCS_WaitForModemReset = 16
   RASCS_WaitForCallback = 17
   RASCS_Projected = 18
   RASCS_StartAuthentication = 19
   RASCS_CallbackComplete = 20
   RASCS_LogonNetwork = 21
   RASCS_SubEntryConnected = 22
   RASCS_SubEntryDisconnected = 23
   RASCS_Interactive = &H1000
   RASCS_RetryAuthentication = &H1001
   RASCS_CallbackSetByCaller = &H1002
   RASCS_PasswordExpired = &H1003
   RASCS_InvokeEapUI = &H1004
   RASCS_Connected = &H2000
   RASCS_Disconnected = &H2001
End Enum

Private Declare Function RasEnumConnections _
      Lib "rasapi32.dll" Alias "RasEnumConnectionsA" _
         (lpRasconn As Any, _
          lpcB As Long, _
          lpcConnections As Long) As Long

' VB "friendly" RASCONN structure

Private Type VBRASCONN
   hRasConn As Long
   sEntryName As String
   sDeviceType As String
   sDeviceName As String
   sPhonebook  As String
   lngSubEntry As Long
   guidEntry(15) As Byte
End Type

Private Declare Function RasGetConnectStatus _
      Lib "rasapi32.dll" Alias "RasGetConnectStatusA" _
        (ByVal hRasConn As Long, _
         lpRasConnStatus As Any) As Long

' VB "friendly" RASCONNSTATUS structure

Private Type VBRASCONNSTATUS
      lRasConnState As RASCONNSTATE
      dwError As Long
      sDeviceType As String
      sDeviceName As String
      sNTPhoneNumber As String
End Type

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
(Destination As Any, Source As Any, ByVal Length As Long)


Public Function RasConnection() As Boolean
   Dim aVBRasConns() As VBRASCONN
   Dim udtVBRasConnStatus As VBRASCONNSTATUS
   Dim isRasConnect As Boolean
   Dim i As Integer

   isRasConnect = False
   If VBRasEnumConnections(aVBRasConns()) > 0 Then 'ret nb connection
      For i = LBound(aVBRasConns, 1) To UBound(aVBRasConns, 1)
         If VBRasGetConnectStatus(aVBRasConns(i).hRasConn, udtVBRasConnStatus) = 0 Then 'no error
            If udtVBRasConnStatus.lRasConnState = RASCS_Connected Then
               isRasConnect = True
               Exit For
            End If
         End If
      Next i
   End If
   
   RasConnection = isRasConnect
End Function

Private Function VBRasEnumConnections(aVBRasConns() As VBRASCONN) As Long

   Dim rtn As Long
   Dim b() As Byte
   Dim aLens As Variant, dwSize As Long
   Dim lpcB As Long, lpConns As Long
   Dim i As Long
   
   ReDim b(3)
   aLens = Array(692&, 676&, 412&, 32&)

   For i = 0 To 3
      dwSize = aLens(i)
      CopyMemory b(0), dwSize, 4
      lpcB = 4
      rtn = RasEnumConnections(b(0), lpcB, lpConns)
      If rtn <> 632 And rtn <> 610 Then Exit For
   Next i
   
   VBRasEnumConnections = lpConns
   If lpConns = 0 Then Exit Function
   
   lpcB = dwSize * lpConns
   ReDim b(lpcB - 1)
   CopyMemory b(0), dwSize, 4
   rtn = RasEnumConnections(b(0), lpcB, lpConns)
   
   ' now copy the bytes to the aVBRasConns array
   ReDim aVBRasConns(lpConns - 1)
   For i = 0 To lpConns - 1
      With aVBRasConns(i)
         CopyMemory .hRasConn, b(i * dwSize + 4), 4
         If dwSize = 32& Then
            CopyByteToTrimmedString .sEntryName, b(i * dwSize + 8), 21&
         Else
            CopyByteToTrimmedString .sEntryName, b(i * dwSize + 8), 257&
            CopyByteToTrimmedString .sDeviceType, b(i * dwSize + 265), 17&
            CopyByteToTrimmedString .sDeviceName, b(i * dwSize + 282), 129&
            If dwSize > 412& Then
              CopyByteToTrimmedString .sPhonebook, b(i * dwSize + 411), 260&
              CopyMemory .lngSubEntry, b(i * dwSize + 672), 4
              If dwSize > 676& Then
                CopyMemory .guidEntry(0), b(i * dwSize + 676), 16
              End If
            End If
         End If
      End With
   Next i
End Function

Private Function VBRasGetConnectStatus _
               (hRasConn As Long, _
               udtVBRasConnStatus As VBRASCONNSTATUS) As Long

   Dim i As Long, dwSize As Long, rtn As Long
   Dim aVarLens As Variant
   Dim b() As Byte

   aVarLens = Array(288&, 160&, 64&)
   
   For i = 0 To 2
      dwSize = aVarLens(i)
      ReDim b(dwSize - 1)
      CopyMemory b(0), dwSize, 4
      rtn = RasGetConnectStatus(hRasConn, b(0))
      If rtn <> 632 Then Exit For
   Next i
   
   VBRasGetConnectStatus = rtn
   If rtn <> 0 Then Exit Function
      
   With udtVBRasConnStatus
      CopyMemory .lRasConnState, b(4), 4
      CopyMemory .dwError, b(8), 4
      CopyByteToTrimmedString .sDeviceType, b(12), 17&
      If dwSize = 64& Then
         CopyByteToTrimmedString .sDeviceName, b(29), 33&
      ElseIf dwSize = 160& Then
         CopyByteToTrimmedString .sDeviceName, b(29), 129&
      Else
         CopyByteToTrimmedString .sDeviceName, b(29), 129&
         CopyByteToTrimmedString .sNTPhoneNumber, b(158), 129&
      End If
   End With
   
End Function

' helper function
Private Sub CopyByteToTrimmedString(strToCopyTo As String, _
                              bPos As Byte, lngMaxLen As Long)
   Dim strTemp As String, lngLen As Long
   strTemp = String(lngMaxLen + 1, 0)
   CopyMemory ByVal strTemp, bPos, lngMaxLen
   lngLen = InStr(strTemp, Chr$(0)) - 1
   strToCopyTo = Left$(strTemp, lngLen)
End Sub
