Attribute VB_Name = "Systemtray"
Option Explicit

Private Declare Function GetTopWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long

Private Const SM_CXBORDER = 5
Private Const SM_CYBORDER = 6
Private Const SM_CYCAPTION = 4
Private Const SM_CYMENU = 15
Private Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long

Private Type POINTAPI
        X As Long
        Y As Long
End Type
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long

Private screenx As Long
Private screeny As Long

Private Const MAX_TOOLTIP As Integer = 64
Private Const NIF_ICON = &H2
Private Const NIF_MESSAGE = &H1
Private Const NIF_TIP = &H4
Private Const NIM_ADD = &H0
Private Const NIM_DELETE = &H2
Private Const WM_MOUSEMOVE = &H200
Private Const WM_LBUTTONDOWN = &H201
Private Const WM_LBUTTONUP = &H202
Private Const WM_LBUTTONDBLCLK = &H203
Private Const WM_RBUTTONDOWN = &H204
Private Const WM_RBUTTONUP = &H205
Private Const WM_RBUTTONDBLCLK = &H206

Private Type NOTIFYICONDATA
    cbSize           As Long
    hwnd             As Long
    uID              As Long
    uFlags           As Long
    uCallbackMessage As Long
    hIcon            As Long
    szTip            As String * MAX_TOOLTIP
End Type
Private nfIconData As NOTIFYICONDATA

Private Declare Function Shell_NotifyIcon Lib "shell32.dll" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, lpData As NOTIFYICONDATA) As Long

Public Sub add_systemtray_icon(formref As Form)
'
' Add this application's icon to the system tray.
'
' Parm 1 = Handle of the window to receive notification messages
'          associated with an icon in the taskbar status area.
' Parm 2 = Icon to display.
' Parm 3 = Handle of icon to display.
' Parm 4 = Tooltip displayed when cursor moves over system tray icon.
'
With nfIconData
    .hwnd = formref.hwnd
    .uID = formref.Icon
    .uFlags = NIF_ICON Or NIF_MESSAGE Or NIF_TIP
    .uCallbackMessage = WM_MOUSEMOVE
    .hIcon = formref.Icon.Handle
    .szTip = App.Title & vbNullChar
    .cbSize = Len(nfIconData)
End With
Call Shell_NotifyIcon(NIM_ADD, nfIconData)

End Sub

Public Sub remove_systemtray_icon(formref As Form)
'
' Remove this application from the System Tray.
'
Call Shell_NotifyIcon(NIM_DELETE, nfIconData)
End Sub

Public Sub movein_MouseMove(formref As Form, xpos As Single, ypos As Single, ByRef hwndapp As Long)
Dim lMsg As Single

Dim mousescreenpos As POINTAPI
Dim retcode As Long, hwndtopwnd As Long, hwndparent As Long
Dim formisshown As Boolean

'
' Determine the event that happened to the System Tray icon.
' Left clicking the icon displays a message box.
' Right clicking the icon creates an instance of an object from an
' ActiveX Code component then invokes a method to display a message.
'
With formref

lMsg = xpos / Screen.TwipsPerPixelX
   Select Case lMsg
       Case WM_LBUTTONUP
       Case WM_RBUTTONUP
         If IsConnected2net Then
            .pop_submenu(0).Enabled = True
            .pop_submenu(1).Enabled = True
         Else
            .pop_submenu(0).Enabled = False
            .pop_submenu(1).Enabled = False
         End If
         .pop_submenu(0).Checked = EnabledKeepAlive
         
         retcode = GetCursorPos(mousescreenpos)
         screenx = (mousescreenpos.X - GetSystemMetrics(SM_CXBORDER)) * Screen.TwipsPerPixelX - .Left
         'screeny = (mousescreenpos.Y - GetSystemMetrics(SM_CYBORDER) - GetSystemMetrics(SM_CYCAPTION) - GetSystemMetrics(SM_CYMENU)) * Screen.TwipsPerPixelY - .Top
         screeny = (mousescreenpos.Y - GetSystemMetrics(SM_CYBORDER) - GetSystemMetrics(SM_CYCAPTION)) * Screen.TwipsPerPixelY - .Top
         .tmrCloseMenu.Enabled = True
         .PopupMenu .pop_menu, , screenx, screeny
       'Case WM_MOUSEMOVE
       'Case WM_LBUTTONDOWN
       'Case WM_LBUTTONDBLCLK
       'Case WM_RBUTTONDOWN
       'Case WM_RBUTTONDBLCLK
       'Case Else
   End Select
End With
End Sub
