Attribute VB_Name = "regSaveLoad_bas"
Option Explicit

Public Function GetSettingsCustom(mainkey As String, subkey As String, valueskey As String, defaultvalue As String) As String
   Dim svalue As String
   
   If fReadValue("HKLM", "Software\Elusive Masquerade\" & mainkey & "\" & subkey, valueskey, "S", "", svalue) = 0 Then
      GetSettingsCustom = svalue
   Else
      GetSettingsCustom = defaultvalue
   End If
End Function

Public Sub SaveSettingsCustom(mainkey As String, subkey As String, valueskey As String, value2save As String)
   If fWriteValue("HKLM", "Software\Elusive Masquerade\" & mainkey & "\" & subkey, valueskey, "S", value2save) = 0 Then
      'no error
   End If
End Sub
Public Sub loadISPfromregistry()
   Dim i As Long, nbofISP As Long
   Dim svalue As String, svalue1 As String, svalue2 As String, svalue3 As String, svalue4 As String

   ReDim isp_allisp(0)

   If fReadValue("HKLM", "Software\Elusive Masquerade\" & App.Title & "\ISP", "NumberISP", "S", "", svalue) = 0 Then
      On Error GoTo toobignumber
      nbofISP = CLng(Val(svalue))
      On Error GoTo 0
      If nbofISP > MAXISP Then nbofISP = MAXISP
      If nbofISP > 0 Then
         For i = 1 To nbofISP
            If fReadValue("HKLM", "Software\Elusive Masquerade\" & App.Title & "\ISP", Trim$(Str$(i)) & "_Path", "S", "", svalue) = 0 And _
               fReadValue("HKLM", "Software\Elusive Masquerade\" & App.Title & "\ISP", Trim$(Str$(i)) & "_Name", "S", "", svalue1) = 0 And _
               fReadValue("HKLM", "Software\Elusive Masquerade\" & App.Title & "\ISP", Trim$(Str$(i)) & "_Delay", "S", "", svalue2) = 0 And _
               fReadValue("HKLM", "Software\Elusive Masquerade\" & App.Title & "\ISP", Trim$(Str$(i)) & "_Engine", "S", "", svalue3) = 0 And _
               fReadValue("HKLM", "Software\Elusive Masquerade\" & App.Title & "\ISP", Trim$(Str$(i)) & "_KeepAlive", "S", "", svalue4) = 0 Then
               
               If checkvalidpath(svalue) And _
                  checkvalidname(svalue1) And _
                  checkvalidtime(svalue2) And _
                  checkvalidengine(svalue3) And _
                  checkvalidkeepalive(svalue4) Then
                  
                  svalue1 = GetUniqueName(svalue1, 1)
                  
                  ReDim Preserve isp_allisp(UBound(isp_allisp, 1) + 1)
                  With isp_allisp(UBound(isp_allisp, 1))
                     .Pathofthefreeisp = Trim$(svalue)
                     .Nameofthefreeisp = Trim$(svalue1)
                     .ConnectionDelayofthefreeisp = CLng(Val(svalue2))
                     .Engineofthefreeisp = CInt(Val(svalue3))
                     .KeepAlive = CLng(Val(svalue4))
                  End With
               Else
                  Exit For
               End If
            Else
               Exit For
            End If
         Next i
      End If
      
      If fReadValue("HKLM", "Software\Elusive Masquerade\" & App.Title & "\ISP", "DefaultISP", "S", "", svalue) = 0 Then
         On Error GoTo toobignumber1
         currentISP = CLng(Val(svalue))
         On Error GoTo 0
         If currentISP < 0 Or currentISP > UBound(isp_allisp, 1) Then
            currentISP = 0
         End If
      Else
         currentISP = 0
      End If
   End If
   Exit Sub
   
toobignumber:
   Err.Clear
   nbofISP = 0
   Resume Next
toobignumber1:
   Err.Clear
   currentISP = 0
   Resume Next
End Sub

Public Sub saveISP2registry()
   Dim i As Long

   Call fDeleteKey("HKLM", "Software\Elusive Masquerade\" & App.Title, "ISP")
   
   SaveSettingsCustom App.Title, "ISP", "NumberISP", Trim$(Str$(UBound(isp_allisp, 1)))
   Call saveDefaultISP2registry
   For i = 1 To UBound(isp_allisp, 1)
      With isp_allisp(i)
         SaveSettingsCustom App.Title, "ISP", Trim$(Str$(i)) & "_Path", .Pathofthefreeisp
         SaveSettingsCustom App.Title, "ISP", Trim$(Str$(i)) & "_Name", .Nameofthefreeisp
         SaveSettingsCustom App.Title, "ISP", Trim$(Str$(i)) & "_Delay", Trim$(Str$(.ConnectionDelayofthefreeisp))
         SaveSettingsCustom App.Title, "ISP", Trim$(Str$(i)) & "_Engine", Trim$(Str$(.Engineofthefreeisp))
         SaveSettingsCustom App.Title, "ISP", Trim$(Str$(i)) & "_KeepAlive", Trim$(Str$(.KeepAlive))
      End With
   Next i
End Sub

Public Sub saveDefaultISP2registry()
   SaveSettingsCustom App.Title, "ISP", "DefaultISP", Trim$(Str$(currentISP))
End Sub

Public Sub loadnbusefromregistry()
   On Error GoTo invalidnumber
   nbuse = CLng(Val(GetSettingsCustom(App.Title, "Settings", "NumberOfUse", Trim$(Str$(defaultuseoffaf)))))
   If nbuse < 0 Then
invalidnumber:
      If Err Then Err.Clear
      nbuse = defaultuseoffaf
   End If
   On Error GoTo 0
End Sub

Public Sub savenbuse2registry()
   SaveSettingsCustom App.Title, "Settings", "NumberOfUse", Trim$(Str$(nbuse))
End Sub

Public Sub loadstartingpos()
   On Error GoTo invalidnumber
   xstartingpos = CInt(Val(GetSettingsCustom(App.Title, "Settings", "StartingXpos", "-1")))
   ystartingpos = CInt(Val(GetSettingsCustom(App.Title, "Settings", "StartingYpos", "-1")))
   
   If xstartingpos < 0 Or xstartingpos > (Screen.Width - Main.Width) Or ystartingpos < 0 Or ystartingpos > (Screen.Height - Main.Height) Then
invalidnumber:
      If Err Then Err.Clear
      xstartingpos = Screen.Width / 2 - (Main.Width / 2)
      ystartingpos = Screen.Height / 2 - (Main.Height / 2)
   End If
   On Error GoTo 0
End Sub

Public Sub savestartingpos()
   SaveSettingsCustom App.Title, "Settings", "StartingXpos", Trim$(Str$(Main.Left))
   SaveSettingsCustom App.Title, "Settings", "StartingYpos", Trim$(Str$(Main.Top))
End Sub

Public Sub loadbrowserfromregistry()
   Dim tempinteger As Integer

   On Error GoTo invalidnumber
   tempinteger = CInt(Val(GetSettingsCustom(App.Title, "Settings", "AutoStartBrowser", Trim$(Str$(defaultstartbrowser)))))
   If tempinteger = 0 Then
      currentstartbrowser = 0
   ElseIf tempinteger = 1 Then
      currentstartbrowser = 1
   Else
invalidnumber:
      If Err Then Err.Clear
      currentstartbrowser = defaultstartbrowser
   End If
   On Error GoTo 0
End Sub

Public Sub savebrowser2registry()
   SaveSettingsCustom App.Title, "Settings", "AutoStartBrowser", Trim$(Str$(currentstartbrowser))
End Sub

Public Sub loadlaunchfromregistry()
   Dim tempinteger As Integer

   On Error GoTo invalidnumber
   tempinteger = CInt(Val(GetSettingsCustom(App.Title, "Settings", "AutoLaunch", Trim$(Str$(defaultautolaunch)))))
   If tempinteger = 0 Then
      currentautolaunch = 0
   ElseIf tempinteger = 1 Then
      currentautolaunch = 1
   Else
invalidnumber:
      If Err Then Err.Clear
      currentautolaunch = defaultautolaunch
   End If
   On Error GoTo 0
End Sub

Public Sub savelaunch2registry()
   SaveSettingsCustom App.Title, "Settings", "AutoLaunch", Trim$(Str$(currentautolaunch))
End Sub

Public Sub loadnetdetectionfromregistry()
   Dim tempinteger As Integer

   On Error GoTo invalidnumber
   tempinteger = CInt(Val(GetSettingsCustom(App.Title, "Settings", "NetDetection", Trim$(Str$(defaultEngine)))))
   If tempinteger >= 0 And tempinteger < nbNetDetection Then
      currentNetDetection = tempinteger
   Else
invalidnumber:
      If Err Then Err.Clear
      currentNetDetection = defaultNetDetection
   End If
   On Error GoTo 0
End Sub

Public Sub savenetdetection2registry()
   SaveSettingsCustom App.Title, "Settings", "NetDetection", Trim$(Str$(currentNetDetection))
End Sub

Public Sub savepathinregistry()
   SaveSettingsCustom App.Title, "Settings", "ApplicationPath", IIf(Mid$(App.Path, Len(App.Path)) = "\", Mid$(App.Path, Len(App.Path) - 1), App.Path)
   SaveSettingsCustom App.Title, "Settings", "ApplicationEXE", App.EXEName & ".exe"
End Sub

Public Function loadversionfromregistry() As String
   loadversionfromregistry = GetSettingsCustom(App.Title, "Settings", "Version", "")
End Function

Public Sub saveversion2registry()
   SaveSettingsCustom App.Title, "Settings", "Version", App.Major & "." & App.Minor & "." & App.Revision
End Sub
